﻿Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        CarregarImpressoras()
    End Sub

    Private Sub CarregarImpressoras()
        ImpressoraComboBox.Items.Clear()

        For Each Impressora In System.Drawing.Printing.PrinterSettings.InstalledPrinters
            ImpressoraComboBox.Items.Add(Impressora)
        Next
    End Sub

    Private Sub ImprimirButton_Click(sender As Object, e As EventArgs) Handles ImprimirButton.Click
        Using Pd = New System.Drawing.Printing.PrintDocument()
            Pd.PrinterSettings.PrinterName = ImpressoraComboBox.SelectedItem.ToString()
            AddHandler Pd.PrintPage, AddressOf Pd_PrintPage
            Texto = ImpressaoTextBox.Text
            Pd.Print()
        End Using
    End Sub

    Private Texto As String
    Private Sub Pd_PrintPage(sender As Object, e As System.Drawing.Printing.PrintPageEventArgs)
        Using Font = New Font("Times New Roman", 14)
            Using Brush = New SolidBrush(Color.Black)
                Dim Caracteres As Integer = 0
                Dim Linhas As Integer = 0

                e.Graphics.MeasureString(Texto, Font, New Size(e.MarginBounds.Width, e.MarginBounds.Height - Font.Height + 1), StringFormat.GenericTypographic, Caracteres, Linhas)

                e.Graphics.DrawString(Texto.Substring(0, Caracteres), Font, Brush, e.MarginBounds)

                Texto = Texto.Substring(Caracteres)

                e.HasMorePages = Not String.IsNullOrWhiteSpace(Texto)
            End Using
        End Using
    End Sub
End Class
